<script setup lang="ts">
import { computed, ref, watch } from 'vue'

import BuyStockList from '@/components/BuyStockList.vue'
import BSPaperItemList from '@/components/BSPaperItemList.vue'

import { useAuthStore } from '@/stores/auth'

import { type BSPaperItem } from '@/types/BSPaperItem'
import { type BuyStock } from '@/types/BuyStock'
import type { BSPaper } from '@/types/BSPaper'
import BuyStockPaper from './BuyStockPaper.vue'
import { onMounted } from 'vue'
import { useBSPaperStore } from '@/stores/bspaper'
import { useStockBuyStore } from '@/stores/stockbuy'

const bsPaperStore = useBSPaperStore()
const bspaperStore = useBSPaperStore()
const authStore = useAuthStore()

const snackbar = ref(false)
const log = ref('')
const buyStock = ref<BuyStock>()
const bspaperItemList = ref<typeof BSPaperItemList | null>(null)
const dialogBSPaper = ref(false)
function selected(b: BuyStock) {
  if (!b.id) return
  buyStock.value = b
  const newBSPaperItem: BSPaperItem = {
    id: -1,
    name: b.name,
    price: b.price,
    qty: 1,
    unit: b.unit,
    buystockId: b.id
  }
  bspaperStore.addBSPaperItem(newBSPaperItem)
  snackbar.value = true
}

const currentUser = authStore.getCurrentUser()
const stockBuyStore = useStockBuyStore()
// const refreshBSPaperItems = () => {
//   bspaperStore.bspaperItems.value = [...bspaperItems.value]
// }
function showdeldialog() {
  bsPaperStore.showDeleteDialog()
}
const tab = ref(null)
onMounted(async () => {
  await stockBuyStore.getBuyStocks()
})
</script>

<template>
  <v-container>
    <v-row>
      <v-col>{{ log }}</v-col>
    </v-row>
    <v-row>
      <!-- คอลัมน์ซ้าย -->
      <v-col cols="12" md="6">
        <v-sheet max-width="600" min-width="300" height="720" elevation="3" class="overflow-auto">
          <v-tabs v-model="tab" color="deep-purple-accent-4" align-tabs="center">
            <v-tab>Buy Stock Item</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <BuyStockList
                :buyStocks="stockBuyStore.buyStocks"
                @selected="selected"
              ></BuyStockList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>
      <!-- คอลัมน์ขวา -->
      <v-col cols="12" md="6">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <BSPaperItemList
                v-model="bspaperStore.bsPaperItems"
                :editable="true"
              ></BSPaperItemList>
            </v-col>
            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="200" elevation="6">
                <v-container style="text-align: center">
                  <v-row>
                    <v-col class="text-h5" cols="12"
                      >รวมเงิน : {{ bspaperStore.bsPaper.total }} บาท</v-col
                    >
                    <v-col class="text-h5" cols="12"
                      >รวม : {{ bspaperStore.bsPaper.amount }} ชิ้น</v-col
                    >
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="100" elevation="3">
                <v-container style="text-align: center">
                  <v-row>
                    <v-col><v-btn color="red" @click="showdeldialog">ยกเลิก</v-btn></v-col>
                    <v-col>
                      <v-btn @click="dialogBSPaper = true">ชำระเงิน</v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <!-- พังตรงนี้ กดไดอะลอกไม่ขึ้น มันไม่แดง แต่มันผิด-->
  <BuyStockPaper
    v-model:modelValue="dialogBSPaper"
    :bspaper="bspaperStore.bsPaper"
    :bspaperItems="bspaperStore.bsPaperItems"
    @agree="
      () => {
        bspaperStore.Buystock()
      }
    "
  ></BuyStockPaper>
  <v-snackbar v-model="snackbar">
    {{ buyStock }}

    <template v-slot:actions>
      <v-btn color="pink" variant="text" @click="snackbar = false"> Close </v-btn>
    </template>
  </v-snackbar>
  <v-dialog v-model="bsPaperStore.DeleteDialog" max-width="350px">
    <v-card style="text-align: center">
      <v-card-title class="text-h5" style="text-align: center">ยกเลิก</v-card-title>
      คุณต้องการที่จะยกเลิกคําสั่งซื้อนี้หรือไม่
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="
            () => {
              bsPaperStore.DeleteDialog = false
            }
          "
          >No</v-btn
        >
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="
            () => {
              bsPaperStore.DeleteDialog = false
              bsPaperStore.clearForm()
            }
          "
          >Yes</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
